<script>
import QuestionTypeConformity from "@/components/Question/QuestionTypeConformity";
import QuestionTypeOpenAnswer from "@/components/Question/QuestionTypeOpenAnswer";
import QuestionTypeSequencing from "@/components/Question/QuestionTypeSequencing";
import QuestionTypeSimple from "@/components/Question/QuestionTypeSimple";
import QuestionTypeSimpleOneFail from "@/components/Question/QuestionTypeSimpleOneFail";
import QuestionTypeSimpleWithFewVariants from "@/components/Question/QuestionTypeSimpleWithFewVariants";

export default {
  components: {
    "question-type-conformity": QuestionTypeConformity,
    "question-type-open-answer": QuestionTypeOpenAnswer,
    "question-type-simple": QuestionTypeSimple,
    "question-type-simple-few-variants": QuestionTypeSimpleWithFewVariants,
    "question-type-simple-one-fail": QuestionTypeSimpleOneFail,
    "question-type-sequencing": QuestionTypeSequencing,
  },
  props: {
    type: {
      type: String,
      default: () => null,
    },
    value: {
      type: Object,
      default: () => {},
    },
    viewMode: {
      type: Boolean,
      default: () => false,
    }
  },
  methods: {
    inputHandle($e) {
      this.$emit('input', $e);
    }
  },
  computed: {
    componentName() {
      return `question-type-${this.type}`;
    }
  }
};
</script>
<template>
  <component :is="componentName" :value="{ ...$attrs }" :viewMode="viewMode" :readonly="viewMode" @input="inputHandle"/>
</template>